﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.C1Schedule;

namespace Modify_Scheduler_AppointmentEditBox_CSharp
{
    public partial class Form1 : Form
    {
        // Flag to determine whether the appointment box is used
        // for creating or modifying an appointment
        bool newEditingStatus = false;

        // refers to the appoinemtent being modified
        C1.C1Schedule.Appointment currentAppointment;

        // refers to the user defined Appointment Form
        C1.Win.C1Schedule.Forms.AppointmentForm _customAppointmentForm;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1Schedule1.PrintInfo.IsPrintingEnabled = false;
        }

        private void c1Schedule1_BeforeAppointmentCreate(object sender, CancelEventArgs e)
        {
            e.Cancel = true;

            currentAppointment = new C1.C1Schedule.Appointment();
            currentAppointment.Start = this.c1Schedule1.SelectedInterval.Start;
            currentAppointment.End = this.c1Schedule1.SelectedInterval.End;
            this.c1Schedule1.DataStorage.AppointmentStorage.Appointments.Add(currentAppointment);

            _customAppointmentForm = new C1.Win.C1Schedule.Forms.AppointmentForm(this.c1Schedule1, currentAppointment);
            _customAppointmentForm.FormClosing += new FormClosingEventHandler(_customAppointmentForm_FormClosing);

            // it defines whther the current Appointment box
            // will open for new Appointment or modifying an appointment
            newEditingStatus = true;

            
            ModifyForm(_customAppointmentForm);

            _customAppointmentForm.ShowDialog(this);

        }

        private void c1Schedule1_BeforeAppointmentShow(object sender, CancelAppointmentEventArgs e)
        {
            e.Cancel = true;

            this.c1Schedule1.DataStorage.AppointmentStorage.Appointments.Add(e.Appointment);

            _customAppointmentForm = new C1.Win.C1Schedule.Forms.AppointmentForm(this.c1Schedule1, e.Appointment);
            _customAppointmentForm.FormClosing += new FormClosingEventHandler(_customAppointmentForm_FormClosing);

            ModifyForm(_customAppointmentForm);

            _customAppointmentForm.ShowDialog(this);
        }

        void _customAppointmentForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            newEditingStatus = false;
        }

        public void ModifyForm(C1.Win.C1Schedule.Forms.AppointmentForm _appform)
        {
            // Loop through the controls to do the modifications
            for (int i = _appform.Controls.Count - 1; i >= 0; i += -1)
            {
                Control c = _appform.Controls[i];
                if (c.GetType() == typeof(Panel))
                {
                    for (int j = c.Controls.Count - 1; j >= 0; j += -1)
                    {
                        Control d = c.Controls[j];

                        if (d.GetType() == typeof(CheckBox))
                        {
                            // Uncheck the reminder check box while 
                            // creating a new appointment
                            if (d.Name == "chkReminder")
                            {
                                if (newEditingStatus == true)
                                {
                                    ((CheckBox)d).Checked = false;

                                }

                            }
                        }
                    }

                }
                else if (c.GetType() == typeof(ToolStrip))
                {

                    for (int j = 0; j <= ((ToolStrip)c).Items.Count - 1; j++)
                    {
                        ToolStripItem d = ((ToolStrip)c).Items[j];
                        if (d.GetType() == typeof(ToolStripButton))
                        {
                            if (d.Name == "btnSave")
                            {
                                ((ToolStripButton)d).Click += SaveButton_Click;
                            }
                        }
                    }

                    // Add a new custom button
                    if (c.Name.Equals("toolStrip1"))
                    {
                        ToolStripButton btn = new ToolStripButton();
                        btn.Text = "New Button";
                        btn.Click += CustomButton_Click;
                        ((ToolStrip)c).Items.Add(btn);
                    }
                }
            }

        }


        private void CustomButton_Click(System.Object sender, System.EventArgs e)
        {
            if ((currentAppointment != null))
            {
                MessageBox.Show("This is a new button Action box");
            }

        }

        private void SaveButton_Click(System.Object sender, System.EventArgs e)
        {
            Appointment app = ((C1.Win.C1Schedule.Forms.AppointmentForm)((ToolStripButton)sender).Owner.FindForm()).Appointment;
            c1Schedule1.DataStorage.AppointmentStorage.Appointments.Add(app);
        }

    }
}
